Index: src/uk/me/parabola/mkgmap/build/MapBuilder.java
===================================================================
--- src/uk/me/parabola/mkgmap/build/MapBuilder.java	(revision 4373)
+++ src/uk/me/parabola/mkgmap/build/MapBuilder.java	(working copy)
@@ -278,6 +278,10 @@
 		if (mapInfo.isEmpty())
 			getMapInfo();
 
+		if (map.getNodFile() != null) {
+			// make sure that island detection is done before we write any map data so that NOD flags are properly set 
+			src.getRoadNetwork().getCenters();
+		}
 		normalizeCountries(src);
 		
 		processCities(map, src);
@@ -1180,6 +1184,19 @@
 			LineMergeFilter merger = new LineMergeFilter();
 			lines = merger.merge(lines, res);
 		}
+		
+		// sort lines so that roads appear after non-routable lines and roads
+		// without NOD appear at the end. Else we see routing errors when island detection removes roads from NOD 
+		lines.sort((o1, o2) -> {
+			if (o1.isRoad()) {
+				if (o2.isRoad()) {
+					return Boolean.compare(((MapRoad) o1).getRoadDef().skipAddToNOD(), ((MapRoad) o2).getRoadDef().skipAddToNOD());
+				}
+				return 1;
+			}
+			return o2.isRoad() ? -1 : 0;
+		});
+		
 		LayerFilterChain filters = new LayerFilterChain(config);
 		if (enableLineCleanFilters && (res < 24)) {
 			filters.addFilter(new RoundCoordsFilter());
